   /*-----------------------------------------------------------.
  /                      Custom - Fish Eye                      /
  '-----------------------------------------------------------*/

  //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //Copyright (c) 2009-2015 Gilcher Pascal aka Marty McFly
  //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //Credits :: icelaglace, a.o => (ported from some blog, author unknown)
  //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  /*-----------------------.
  | ::     Settings     :: |
  '-----------------------*/

// MAY BE SAFELY MOVED TO THE END OF SweetFX_settings.txt FOR CONVINIENCE.


// BUT DON'T MOVE ANYTHING ELSE BELOW THIS LINE
#ifdef USE_ENB_SETTINGS

#if ((USE_ENB_SETTINGS + USE_CUSTOM) >= 2)
  #if (USE_ENB_SETTINGS == 1)
    PARAM_ENABLE(Custom, "Fish eye:: enabled", USE_CUSTOM, USE_CUSTOM, USE_CUSTOM)
  #else
    PARAM_ENABLE(Custom, "Fish eye:: enabled", 0, 1, 0)
    #define USE_CUSTOM             1
  #endif
float	FisheyeZoom
<
  string UIName="Fish eye:: zoom";
  string UIWidget="spinner";
  float UIMin=0.5;
  float UIMax=1.0;
> = {fFisheyeZoom};
#define fFisheyeZoom FisheyeZoom
float	FisheyeDistortion
<
  string UIName="Fish eye:: distortion";
  string UIWidget="spinner";
  float UIMin=-0.3;
  float UIMax=0.3;
> = {fFisheyeDistortion};
#define fFisheyeDistortion FisheyeDistortion
float	FisheyeDistortionCubic
<
  string UIName="Fish eye:: distortion cubic";
  string UIWidget="spinner";
  float UIMin=-0.3;
  float UIMax=0.3;
> = {fFisheyeDistortionCubic};
#define fFisheyeDistortionCubic FisheyeDistortionCubic
float	FisheyeColorShift
<
  string UIName="Fish eye:: color shift";
  string UIWidget="spinner";
  float UIMin=-0.1;
  float UIMax=0.1;
> = {fFisheyeColorshift};
#define fFisheyeColorshift FisheyeColorShift
#endif

#endif

  /*-----------------------.
  | ::     Effect       :: |
  '-----------------------*/

float3 CustomPass(float4 position : SV_Position, float2 texcoord : TEXCOORD0) : SV_Target
{
  float4 coord=0.0;
	coord.xy=texcoord.xy;
	coord.w=0.0;

	float4 color = 0.0.xxxx;

	float3 eta = float3(1.0+fFisheyeColorshift*0.9,1.0+fFisheyeColorshift*0.6,1.0+fFisheyeColorshift*0.3);
	float2 center;
	center.x = coord.x-0.5;
	center.y = coord.y-0.5;
	float LensZoom = 1.0/fFisheyeZoom;

	float r2 = (texcoord.x-0.5) * (texcoord.x-0.5) + (texcoord.y-0.5) * (texcoord.y-0.5);
	float f = 0;

	if( fFisheyeDistortionCubic == 0.0){
		f = 1 + r2 * fFisheyeDistortion;
	}else{
                f = 1 + r2 * (fFisheyeDistortion + fFisheyeDistortionCubic * sqrt(r2));
	};

	float x = f*LensZoom*(coord.x-0.5)+0.5;
	float y = f*LensZoom*(coord.y-0.5)+0.5;
	float2 rCoords = (f*eta.r)*LensZoom*(center.xy*0.5)+0.5;
	float2 gCoords = (f*eta.g)*LensZoom*(center.xy*0.5)+0.5;
	float2 bCoords = (f*eta.b)*LensZoom*(center.xy*0.5)+0.5;

	color.x = tex2D(s0,rCoords).r;
	color.y = tex2D(s0,gCoords).g;
	color.z = tex2D(s0,bCoords).b;

	return color.rgb;
}
