//+++++++++++++++++++++++++++++++++++++++++++++++++++++//
//                ENBSeries effect file                //
//         visit http://enbdev.com for updates         //
//       Copyright (c) 2007-2015 Boris Vorontsov       //
//----------------------ENB PRESET---------------------//
//            - PHOTOREALISTIC COMMONWEALTH -          //
//                - ENBSeries v0.288 -                 //
//-----------------------CREDITS-----------------------//
// Boris: For ENBSeries and his knowledge and codes    //
// JawZ: Author and developer of this file             //
//+++++++++++++++++++++++++++++++++++++++++++++++++++++//




//++++++++++++++++++++++++++++++++++++++++++++++++++++
// INTERNAL PARAMETERS BEGINS HERE, CAN BE MODIFIED
//++++++++++++++++++++++++++++++++++++++++++++++++++++

/// For quick changing between effects, not optimal for preset creation!
/// Activate/deactivate by removing/adding

#define ACTIVATE_ADAPTDEPTH
#define ACTIVATE_BLOOMDEPTH
//#define ACTIVATE_BLOOMCTRL
#define ACTIVATE_AGCC             2 	/// 1, 2. Choose one of the given numbers to change AGCC method
#define ACTIVATE_ENPP             2 	/// 1, 2, 3, 4. Choose one of the given numbers to change Post process version
#define ACTIVATE_TONEMAP          4 	/// 1, 2, 3, 4, 5. Choose one of the given numbers to change Tonemap method
#define ACTIVATE_LOCCONTRAST        	/// Not yet a Local Operator, but it's useable as is.
#define ACTIVATE_LOCSATURATION      	/// Not yet a Local Operator, but it's useable as is.
//#define ACTIVATE_SEPIA
#define ACTIVATE_PCC              1 	/// 1, 2. Choose one of the given numbers to change Procedural Color Correction method
//#define ACTIVATE_PALETTE              	/// I'm not even sure why I added this, worst post-process among this bunch, better to use 3DLUT instead of this then.
#define ACTIVATE_3DLUT

/// AGCC    : 1=enbAGCC, 2=msAGCC
/// ENBPP   : 1=V1, 2=V2, 3=V3, 4=Improved V4
/// TONEMAP : 1=NXS PP, 2=Reinhard, 3=Filmic-ALU, 4=Uncharted2D, 5=Improved Tonemapping
/// PCC     : 1=msPCC, 2=enbPCC


float Empty_Row1 <
  string UIName="------------------DEVELOPMENT TOOLS";   string UIWidget="spinner";  float UIMin=0.0;  float UIMax=0.0;
> = {0.0};

  int ENABLE_SPLITSCREEN <
    string UIName = "Enable Split Screen";       string UIWidget="Spinner";  int UIMin=-1;  int UIMax=1;
  > = {0};
    float fSplitPos <
      string UIName="Split Screen: Position X";  string UIWidget="Spinner";  float UIMin=0.0;  float UIMax=1.0;  float UIStep=0.05;
    > = {0.5};
  bool ENABLE_CLIPMODE <
    string UIName = "Visualize Color Clipping";
  > = {false};
  bool SHOW_DEPTH <
    string UIName = "Visualize Depth";
  > = {false};
    int fDevDepth <
      string UIName="Depth: Variable";  string UIWidget="Spinner";  int UIMin=0;
    > = {1000};

float Empty_Row2 <
  string UIName="-------------------COLOR CORRECTION";   string UIWidget="spinner";  float UIMin=0.0;  float UIMax=0.0;
> = {0.0};

  bool ENABLE_AGCC <
    string UIName = "Enable APPLYGAMECOLORCORRECTION";
  > = {true};
  bool ENABLE_GAMMACOR <
    string UIName = "Enable Gamma Correction";
  > = {true};


float Empty_Row3 <
  string UIName="----------------------------";   string UIWidget="spinner";  float UIMin=0.0;  float UIMax=0.0;
> = {0.0};


/*
    int fFromDepth1 <
      string UIName="From Depth";  string UIWidget="Spinner";  int UIMin=0.0;  int UIMax=100000.0;
    > = {300.0};
    int fToDepth1 <
      string UIName="To Depth";  string UIWidget="Spinner";  int UIMin=0.0;  int UIMax=100000.0;
    > = {0.0};
*/


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// EXTERNAL PARAMETERS BEGINS HERE, SHOULD NOT BE MODIFIED UNLESS YOU KNOW WHAT YOU ARE DOING
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// Warning! In this version Weather, TimeOfDay1, TimeOfDay2 are not yet implemented
float4 Timer;            /// x = generic timer in range 0..1, period of 16777216 ms (4.6 hours), y = average fps, w = frame time elapsed (in seconds)
float4 ScreenSize;       /// x = Width, y = 1/Width, z = aspect, w = 1/aspect, aspect is Width/Height
float  AdaptiveQuality;  /// changes in range 0..1, 0 means full quality, 1 lowest dynamic quality (0.33, 0.66 are limits for quality levels)
float4 Weather;          /// x = current weather index, y = outgoing weather index, z = weather transition, w = time of the day in 24 standart hours. Weather index is value from weather ini file, for example WEATHER002 means index==2, but index==0 means that weather not captured.
float4 TimeOfDay1;       /// x = dawn, y = sunrise, z = day, w = sunset. Interpolators range from 0..1
float4 TimeOfDay2;       /// x = dusk, y = night. Interpolators range from 0..1

// External ENB debugging paramaters
float4 tempF1;     /// 0,1,2,3  // Keyboard controlled temporary variables.
float4 tempF2;     /// 5,6,7,8  // Press and hold key 1,2,3...8 together with PageUp or PageDown to modify.
float4 tempF3;     /// 9,0
float4 tempInfo1;  /// xy = cursor position in range 0..1 of screen, z = is shader editor window active, w = mouse buttons with values 0..7
/// tempInfo1 assigned mouse button values
///    0 = none
///    1 = left
///    2 = right
///    3 = left+right
///    4 = middle
///    5 = left+middle
///    6 = right+middle
///    7 = left+right+middle (or rather cat is sitting on your mouse)

float4 Params01[6];  /// MOD PARAMATER, DO NOT MODIFY!
float4 ENBParams01;  /// x - bloom amount; y - lens amount


// TEXTURES
Texture2D TextureColor;       /// HDR color
Texture2D TextureBloom;       /// Fallout4 or ENB bloom
Texture2D TextureLens;        /// ENB lens fx
Texture2D TextureAdaptation;  /// Fallout4 or ENB adaptation
Texture2D TextureDepth;       /// Scene depth
Texture2D TextureAperture;    /// This frame aperture 1*1 R32F hdr red channel only. computed in depth of field shader file


// SAMPLERS
SamplerState Sampler0
{
  Filter=MIN_MAG_MIP_POINT;  AddressU=Clamp;  AddressV=Clamp;  /// MIN_MAG_MIP_LINEAR;
};
SamplerState Sampler1
{
  Filter=MIN_MAG_MIP_LINEAR;  AddressU=Clamp;  AddressV=Clamp;
};


// DATA STRUCTURE
struct VS_INPUT_POST
{
  float3 pos     : POSITION;
  float2 txcoord : TEXCOORD0;
};
struct VS_OUTPUT_POST
{
  float4 pos      : SV_POSITION;
  float2 txcoord0 : TEXCOORD0;
};


// HELPER FUNCTIONS
/// Include the additional shader files containing all helper functions and constants
   #include "/Modular Shaders/msHelpers.fxh"                                /// Required for all files below!
   #include "/Modular Shaders/enbeffect/01_GaussBlur.fxh"
#ifdef ACTIVATE_ADAPTDEPTH
   #include "/Modular Shaders/enbeffect/10_AdaptDepth.fxh"
#endif
//   #include "/Modular Shaders/enbeffect/11_Adaptation.fxh"
#ifdef ACTIVATE_BLOOMDEPTH
   #include "/Modular Shaders/enbeffect/20_BloomDepth.fxh"
#endif
//   #include "/Modular Shaders/enbeffect/21_BloomProcess.fxh"
#ifdef ACTIVATE_BLOOMCTRL
   #include "/Modular Shaders/enbeffect/22_BloomControl.fxh"
#endif
   #include "/Modular Shaders/enbeffect/enbAGCC.fxh"
#if ACTIVATE_AGCC == 2
   #include "/Modular Shaders/enbeffect/30_AGCC.fxh"                        /// 
#endif
#if ACTIVATE_ENPP == 1
   #include "/Modular Shaders/enbeffect/enbPP1.fxh"                         /// 
#endif
#if ACTIVATE_ENPP == 2
   #include "/Modular Shaders/enbeffect/enbPP2.fxh"                         /// 
#endif
#if ACTIVATE_ENPP == 3
   #include "/Modular Shaders/enbeffect/enbPP3.fxh"                         /// 
#endif
#if ACTIVATE_ENPP == 4
   #include "/Modular Shaders/enbeffect/enbPP4.fxh"                         /// 
#endif
//   #include "/Modular Shaders/enbeffect/50_TonemapMethods.fxh"              ///  Not functional in v0.288!
#if ACTIVATE_TONEMAP == 1
   #include "/Modular Shaders/enbeffect/51_NXS.fxh"
#endif
#if ACTIVATE_TONEMAP == 2
   #include "/Modular Shaders/enbeffect/52_HDRReinhard.fxh"
#endif
#if ACTIVATE_TONEMAP == 3
   #include "/Modular Shaders/enbeffect/53_HDRFilmicALU.fxh"
#endif
#if ACTIVATE_TONEMAP == 4
   #include "/Modular Shaders/enbeffect/54_HDRFilmic2D.fxh"
#endif
#if ACTIVATE_TONEMAP == 5
   #include "/Modular Shaders/enbeffect/55_ImprovedTonemap.fxh"
#endif
#ifdef ACTIVATE_LOCCONTRAST
   #include "/Modular Shaders/enbeffect/60_LocalContrast.fxh"               ///  Not functional in v0.286!
#endif
#ifdef ACTIVATE_LOCSATURATION
   #include "/Modular Shaders/enbeffect/61_LocalSaturation.fxh"
#endif
#ifdef ACTIVATE_SEPIA
   #include "/Modular Shaders/enbeffect/64_Sepia.fxh"
#endif
#if ACTIVATE_PCC == 1
   #include "/Modular Shaders/enbeffect/65_PCC.fxh"
#endif
#if ACTIVATE_PCC == 2
   #include "/Modular Shaders/enbeffect/enbPCC.fxh"
#endif
#ifdef ACTIVATE_PALETTE
   #include "/Modular Shaders/enbeffect/enbPalette.fxh"
#endif
#ifdef ACTIVATE_3DLUT
   #include "/Modular Shaders/enbeffect/66_3DLUT.fxh"
#endif


// VERTEX SHADER
VS_OUTPUT_POST VS_Draw(VS_INPUT_POST IN)
{
  VS_OUTPUT_POST OUT;
  
    float4 pos;
    pos.xyz=IN.pos.xyz;
    pos.w=1.0;
    OUT.pos=pos;
    OUT.txcoord0.xy=IN.txcoord.xy;

  return OUT;
}


// PIXEL SHADER
float4 PS_Draw(VS_OUTPUT_POST IN, float4 v0 : SV_Position0) : SV_Target
{
  float4 res;     /// Output
  float4 color;   /// HDR scene color
  float4 ebloom;  /// ENB and FO4 bloom
  float3 lens;    /// ENB lens FX
  float4 eadapt;  /// ENB and FO4 adaptation
  color    = TextureColor.Sample(Sampler0, IN.txcoord0.xy);
  ebloom   = TextureBloom.Sample(Sampler1, IN.txcoord0.xy);
  lens.xyz = TextureLens.Sample(Sampler1, IN.txcoord0.xy).xyz;
  eadapt   = TextureAdaptation.Sample(Sampler0, IN.txcoord0.xy);

/// For use in specific effects only
  float4 eblur;       /// For Local Operators
    eblur      = TextureBloom.Sample(Sampler1, IN.txcoord0.xy);
    eblur.xyz  = GaussBlur(color, eblur, IN.txcoord0.xy);


// Main ENBSeries Post-Processing computations and injections
/// ENB Adaptation
    eadapt.xyz = AvgLuma(eadapt.xyz).y;
#ifdef ACTIVATE_ADAPTDEPTH
    eadapt.xyz = msAdaptation(eadapt, IN.txcoord0.xy);
#endif
//    eadapt.xyz = GetAdaptationTint(gameColor1.xyz, eadapt.xyz);
//    eadapt.xyz = MapLetterBox(gameColor1.xyz, IN.txcoord0.xy);

/// ENB Bloom
//    ebloom.xyz = msBloomProcess(ebloom.xyz, IN.txcoord0.xy);
#ifdef ACTIVATE_BLOOMCTRL
    ebloom.xyz = msBloomControl(ebloom.xyz, IN.txcoord0.xy);
#endif
#ifdef ACTIVATE_BLOOMDEPTH
    ebloom.xyz = msBloomDepth(color, ebloom, IN.txcoord0.xy);
#endif
    if (ENABLE_AGCC==false)  color.rgb += ebloom.xyz * ENBParams01.x;

/// ENB Lens
    color.xyz += lens.xyz * ENBParams01.y;

/// AGCC
#if ACTIVATE_AGCC == 1
    if (ENABLE_AGCC==true) color = enbAGCC(color, IN.txcoord0.xy);  /// Requires enbAGCC.fxh active
#endif
#if ACTIVATE_AGCC == 2
    if (ENABLE_AGCC==true) color = msAGCC(color, IN.txcoord0.xy);  /// Requires 30_AGCC.fxh active
#endif


/// RGB Color Filter


/// ENB Post-Processes
#if ACTIVATE_ENPP >= 1 && ACTIVATE_ENPP <= 4
    color.rgb = enbPP(color.rgb, eadapt.xyz);  /// Requires enbPPX.fxh active, only activate one enbPPX.fxh at a time!
#endif

/// Dynamic Color post-processing
#if ACTIVATE_TONEMAP == 1
    color.rgb = msNXS(color.xyz, ebloom.xyz, eadapt.xyz);
#endif

/// Reinhard, Filmic-ALU, Filmic-Uncharted2D
#if ACTIVATE_TONEMAP >= 2 && ACTIVATE_TONEMAP <= 4
    color.rgb = msHDRTonemap(color.rgb, eblur.xyz, eadapt.xyz);   /// Requires 52_HDRX.fxh active, only activate one HDRX.fxh at a time!
#endif

/// Improved Tonemapping
#if ACTIVATE_TONEMAP == 5
    color.rgb = msImprovedTonemap(color.rgb);  /// Requires 55_ImprovedTonemap.fxh active
#endif

/// Local Contrast
#ifdef ACTIVATE_LOCCONTRAST
  color.rgb = msLocalContrast(color.rgb, eblur.xyz, eadapt.xyz);
#endif

/// Local Saturation
#ifdef ACTIVATE_LOCSATURATION
  color.rgb = msLocalSaturation(color.rgb, eblur.xyz);
#endif

/// Sepia
#ifdef ACTIVATE_SEPIA
    color.rgb = msSepia(color.rgb);  /// Requires 64_Sepia.fxh active
#endif

/// Procedural Color-Correction
#if ACTIVATE_PCC >= 1 && ACTIVATE_PCC <= 2
    color.rgb = msPCC(color.rgb);    /// Requires 65_PCC.fxh or enbPCC.fxh active, only activate one PCC.fxh at a time!
#endif

/// ENB Palette
#ifdef ACTIVATE_PALETTE
    color.rgb = enbPalette(color.rgb, eadapt.xyz);
#endif

/// 3D LUT
#ifdef ACTIVATE_3DLUT
    color.rgb = ms3DLUT(color.rgb);  /// Requires 66_3DLUT.fxh active
#endif

/// Gamma correction for color output, instead of Linear output
  if (ENABLE_GAMMACOR==true) color.xyz = pow(color.xyz, 1.0/2.2);


/// DEVELOPMENT TOOLS
  if (ENABLE_SPLITSCREEN==1) {        /// Single Split-Screen
    float4 gameColor1;
    gameColor1     = TextureColor.Sample(Sampler0, IN.txcoord0.xy);
    if (ENABLE_AGCC==false)  gameColor1.rgb += TextureBloom.Sample(Sampler1, IN.txcoord0.xy).xyz;
    gameColor1     = enbAGCC(gameColor1, IN.txcoord0.xy);
    gameColor1.xyz = pow(gameColor1.xyz, 1.0/2.2);

    color = SplitScreen(gameColor1, color, IN.txcoord0.xy, fSplitPos);  /// SplitScreen("Before", "After", "Split Coordinate", "User Coordinate Input")
  }
  else if (ENABLE_SPLITSCREEN==-1) {  /// Duplicated Split-Screen
    float4 gameColor2;
    gameColor2     = TextureColor.Sample(Sampler0, float2(0.5f + IN.txcoord0.x - 0 / 2.0f, IN.txcoord0.y));
    if (ENABLE_AGCC==false)  gameColor2.rgb += TextureBloom.Sample(Sampler1, float2(0.5f + IN.txcoord0.x - 0 / 2.0f, IN.txcoord0.y)).xyz;
    gameColor2     = enbAGCC(gameColor2, float2(0.5f + IN.txcoord0.x - 0 / 2.0f, IN.txcoord0.y));
    gameColor2.xyz = pow(gameColor2.xyz, 1.0/2.2);

      if (IN.txcoord0.x < 0.5f)       return gameColor2;  /// Original color with AGCC, GC and Bloom
      else if (IN.txcoord0.x > 0.5f)  return color;       /// Full processed color
  }

  if (ENABLE_CLIPMODE==true) {        /// Show which pixels are over- and under-exposed.
    color.rgb = ClipMode(color.rgb);
  }

  if (SHOW_DEPTH==true) {
  float devDepth    = TextureDepth.Sample(Sampler0, IN.txcoord0.xy ).x;
  float devLinDepth = linearDepth(devDepth, 0.5f, fDevDepth);
    color.rgb = float3(1, 0, 0) * devLinDepth;
  }


  res.xyz=saturate(color);
  res.w=1.0;
  return res;
}

// VANILLA POST PROCESS, DO NOT MODIFY!
float4 PS_DrawOriginal(VS_OUTPUT_POST IN, float4 v0 : SV_Position0) : SV_Target
{
    float4 res;
    float4 color;
    color=TextureColor.Sample(Sampler0, IN.txcoord0.xy); /// HDR scene color

// Combines bloom, adaptation
    float4 r0, r1, r2, r3;
    r0.xyz = color.xyz;
    r1.xy  = Params01[4].zw * IN.txcoord0.xy;
    r1.xyz = TextureBloom.Sample(Sampler1, r1.xy).xyz;
    r0.w   = TextureAdaptation.Sample(Sampler0, IN.txcoord0.xy).x;
    r1.w   = Params01[1].z / (0.001 + r0.w);
    r2.x   = r1.w < Params01[1].y;
    r1.w   = r2.x ? Params01[1].y : r1.w;
    r2.x   = Params01[1].x < r1.w;
    r1.w   = r2.x ? Params01[1].x : r1.w;
    r0.xyz = r1.xyz + r0.xyz;
    r0.xyz = r0.xyz * r1.w;
// returns color_adapt

// filmic tonemap
    r1.xyz = r0.xyz + r0.xyz;
    r2.xyz = r0.xyz * 0.3 + 0.05;
    r3.xy  = float2(0.2, 3.333333) * Params01[1].w;
    r2.xyz = r1.xyz * r2.xyz + r3.x;
    r0.xyz = r0.xyz * 0.3 + 0.5;
    r0.xyz = r1.xyz * r0.xyz + 0.06;
    r0.xyz = r2.xyz / r0.xyz;
    r0.xyz = -Params01[1].w * 3.333333 + r0.xyz;
    r1.x   = Params01[1].w * 0.2 + 19.376;
    r1.x   = r1.x * 0.0408564 - r3.y;
    r1.xyz = r0.xyz / r1.x;
// returns filmic result

// post process
    r0.x    = dot(r1.xyz, float3(0.2125, 0.7154, 0.0721));
    r1.xyz  = r1.xyz - r0.x;
    r1.xyz  = Params01[2].x * r1.xyz + r0.x;
    r2.xyz  = r0.x * Params01[3].xyz - r1.xyz;
    r1.xyz  = Params01[3].w * r2.xyz + r1.xyz;
    r1.xyz  = Params01[2].w * r1.xyz - r0.w;
    r0.xyz  = Params01[2].z * r1.xyz + r0.w;
    res.xyz = lerp(r0.xyz, Params01[5].xyz, Params01[5].w);  /// Last color filter used only for certain conditions, like rifle night scope

    res.xyz = pow(res.xyz, 1.0/2.2);  /// Gamma correction for LDR output, instead of Linear output

  res.w=1.0;
  return res;
}


// TECHNIQUES
technique11 Draw <string UIName="ENBSeries";>
{
  pass p0
  {
    SetVertexShader(CompileShader(vs_5_0, VS_Draw()));
    SetPixelShader(CompileShader(ps_5_0, PS_Draw()));
  }
}

technique11 ORIGINALPOSTPROCESS <string UIName="Vanilla";> //do not modify this technique
{
  pass p0
  {
    SetVertexShader(CompileShader(vs_5_0, VS_Draw()));
    SetPixelShader(CompileShader(ps_5_0, PS_DrawOriginal()));
  }
}